@ECHO OFF
TITLE Local Documents Backup
ECHO Local Documents Backup
ECHO Written by: Jason Faulkner
ECHO SysadminGeek.com
ECHO.
ECHO.

SETLOCAL EnableExtensions

REM RoboCopy.exe must be present on the client machine in a folder specified in the PATH variable.
REM For Windows Vista and later have this tool included, but Windows XP and earlier should download
REM this tool from Microsoft and place it in the Windows folder of their machine.

REM Root folder where backup files should be stored.
REM To use the directory containing this script, use: %~dp0
SET BackupDir=%~dp0

REM Message to users:
ECHO.
ECHO Running Local Documents Backup.
ECHO.
ECHO Do not close this window, it will close automatically when finished.
ECHO You can safely minimize this window and continue working.
ECHO.
ECHO.


REM Destination= Specified Backup Folder\Computer Name\Windows User Name
REM Create required folders if they do not exist
SET BackupDir=%BackupDir%\%ComputerName%
SET BackupDir=%BackupDir:\\=\%
IF NOT EXIST "%BackupDir%" MKDIR "%BackupDir%"
SET BackupDir=%BackupDir%\%UserName%
IF NOT EXIST "%BackupDir%" MKDIR "%BackupDir%"

SET LogFile="%BackupDir%\%ComputerName%-%UserName%_BackupLog.txt"

ECHO %ComputerName% Backup Starting > %LogFile%
ECHO. >> %LogFile%
ECHO.

REM Call BackupDirectory with a relative folder name in the %UserProfile% directory
REM To view available directories, run this from the command prompt:
REM 	DIR %UserProfile%
REM Add more directories as needed (i.e. "Downloads", "Favorites", etc.)

ECHO Backing up Documents...
REM Windows Vista / 7
CALL :BackupDirectory "Documents" >> %LogFile%
REM Windows 2000 / XP
CALL :BackupDirectory "My Documents" >> %LogFile%
ECHO Finished
ECHO.
ECHO Backing up Desktop...
CALL :BackupDirectory "Desktop" >> %LogFile%
ECHO Finished
ECHO.

ECHO.
ECHO.
GOTO End

ENDLOCAL


:BackupDirectory
ECHO.
REM Only backup this directory if it exists on the client machine
SET Source="%UserProfile%\%~1"
IF NOT EXIST %Source% GOTO End
SET Dest="%BackupDir%\%~1"
IF NOT EXIST %Dest% MKDIR %Dest%
REM Run the mirror copy:
RoboCopy %Source% %Dest% /V /S /E /COPY:DAT /PURGE /MIR /NP /R:1 /W:30
ECHO.
ECHO.
GOTO End

:End